



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>var 在异步中引发的 bug</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">var 在异步中引发的 bug</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 15:55:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>问题复现</h1>
<div>
<pre class="prettyprint linenums">for (var i = 0; i &lt; 10; i++) {<br />
    $http.get("/uri").then(function(data)){<br />
        mydata[i].data = data;<br />
    }<br />
}</pre>
</div>
<p>报错：</p>
<p>unable to get property 'mydata' of null</p>
<h1>问题原因</h1>
<p>第一步，听说 var 和 let 作用域范围不同，所以特定尝试下 let，看是否能解决这个 bug。</p>
<div>
<pre class="prettyprint linenums">for (let i = 0; i &lt; 10; i++) {<br />
    $http.get("/uri").then(function(data)){<br />
        mydata[i] = data;<br />
    }<br />
}</pre>
</div>
<p>的确没有报错，解决了该 bug。</p>
<p>第二步，在 console 中输出 i 值：发现 var i 时，所有的 i 为 10；let i 时，i 分别为 1 2 3 4 5 6 7 8 9。</p>
<p>后来查阅资料弄清楚该 bug 的原因：</p>
<ol><li>JavaScript 为单线程，异步操作是在所有操作是在主程序结束之后才开始运行。首先是提交所有的 AJAX 操作，其次才是分别执行所有的 AJAX 请求。</li>
<li>var 为全局变量，let 为块级变量。当 AJAX 操作执行时，var i 的 i 由于是全局变量已经变成了 10，自然越界了；let i 的 i 由于是块级变量，还保持块中的值，分别为 1 2 3 4 5 6 7 8 9，所以不会越界。</li></ol>
<p>其实，这也是 let 产生的原因。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8od5dlq.html">php&period;ini 安全配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw4l6r8.html">tomcat server容器解读</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjym0z9.html">HDU 4628 Pieces（DP &plus; 状态压缩）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y2rj5q.html">（转载）struct 与typdef struct的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xzkdr9.html">Directory&period;GetFiles 方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge4lj08.html">&lpar;2&rpar;java程序走一遍工作流activiti</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kw5y59.html">【转】FIO使用指南</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz6ny08.html">『转载』从内存资源中加载C&plus;&plus;程序集：CMemLoadDll</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp4xm7q.html">Python字符串全解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zozdm1q.html">SpringCloud系列&mdash;&mdash;SSO 单点登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mgl5m8.html">熟悉常用的HBase操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj6g1e9.html">Linux jdk 环境变量配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25we53q.html">python 基础之注释变量常量</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j40m3q.html">JSON数组形式字符串转换为List&amp;lt&semi;Map&amp;lt&semi;String&comma;String&amp;gt&semi;&amp;gt&semi;的几种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2zgg19.html">NUMA的取舍与优化设置【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdznze9.html">python大法好&mdash;&mdash;递归、内置函数、函数进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv274yz9.html">Luogu P4727-- 【HNOI2009】图的同构记数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r5x7j9.html">LeetCode-188&period;Best Time to Buy and Sell Stock IV</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w4ppzq.html">Scrapy创建爬虫项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkke0n8.html">R语言 如何用IF语句判断 一个数字的奇偶</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rg301d8.html">HDU - 1067 Gap &lpar;bfs &plus; hash&rpar; &lbrack;kuangbin带你飞&rsqb;专题二</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdp3oxxq.html">react&plus;react-router&plus;react-redux&plus;nodejs&plus;mongodb项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojwgp1q.html">在页面加载后在设置embed 的src 怎么实现？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj2k469.html">shell脚本&mdash;&mdash;mysql</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg31om8.html">Centos小白命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pkdov8.html">304和浏览器http缓存</a>
			</li>
						<li><a href="https://www.batexi.com/a/950vdz08.html">Xmind8 Pro安装教程 Windows</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj2x2x9.html">freemarker报错之二</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge0k4z8.html">Flex内存泄露解决方法和内存释放优化原则</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kn2wz9.html">TypeError&colon;&lowbar;12&period;store&period;query is not a function</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
